// prevajanje: gcc vector_product.c -o vector_product -m32 -masm=intel

#include <stdio.h>
#include <stdlib.h>

int produkt(int *x, int *y, int *z, int size) {
  asm(".intel_syntax noprefix\n"
      "         mov  esi, 0           \n"
      "loop:    push eax              \n"
      "		mov  eax, [ebx+4*esi] \n"
      "         imul eax, [ecx+4*esi] \n"
      "         mov  [edx+4*esi], eax \n"
      "         inc  esi              \n"
      "         pop  eax              \n"
      "         cmp  esi, eax         \n"
      "         jl   loop             \n"
     :
     : "a" (size), "b" (x), "c" (y), "d" (z)
     :
  );
}

int main(int argv, char **args) {
  int a[4] = {7, 5, 3, 4};
  int b[4] = {2, 4, 8, 2};
  int *c = (int*) malloc(4*sizeof(int));
  int i;

  printf("%d\n", produkt(a, b, c, 4));
  for (i=0; i<4; i++)
    printf("%d ", c[i]);
  printf("\n");
}

